import greenfoot.*; 

/**
 * Onze versie van de wereld
 */
public class Oever extends World
{
    private Punten punten;

    private Levens levens;

    private Resultaat resultaat;

    private int pulsen;

    private int snelheid;

    /**
     * Constructor for objects of class Oever.
     */
    public Oever()
    {    
        super(20, 15, 22);

        pulsen = 0;
        snelheid = 30;

        // wat er bovenaan te zien is
        resultaat = new Resultaat();
        addObject (resultaat, 10, 1);

        punten = new Punten(resultaat);
        addObject (punten, 1,0 );

        levens = new Levens(resultaat);
        addObject (levens, 18, 0 );

        // drie aardbeien + één nijlpaard
        for (int i=0; i < 3; i++) {
            addObject (new Aardbei(), 
                Greenfoot.getRandomNumber(20), 
                Greenfoot.getRandomNumber(8)
            );
        }
        addObject (new Nijlpaard(), 10, 13);

        Greenfoot.setSpeed(50);

        setPaintOrder(
            Punten.class, Levens.class,
            Aardbei.class, Kersen.class, Paddenstoel.class,
            Nijlpaard.class
        );
    }

    public int getSnelheid() {
        return snelheid;
    }

    /**
     * Op geregelde tijdstippen komt er een nieuwe aardbei bij
     */
    public void act() {
        pulsen = pulsen + 1;
        if (pulsen == 7 * snelheid) {
            pulsen = 0;
            Voedsel voedsel;
            int willekeurig = Greenfoot.getRandomNumber(24);
            if (willekeurig < 4) {
                voedsel = new Paddenstoel();
            } else if (willekeurig < 7) {
                voedsel = new Kersen();
            } else {
                voedsel = new Aardbei();
            }
            addObject (voedsel, Greenfoot.getRandomNumber(20), 0);
            // laat het programma sneller lopen, maar niet *te* snel
            if (snelheid > 4) {
                snelheid = snelheid - 1;
            }
        }
    }

    /**
     * Verhoog het puntental
     */
    public void verhoogPunten(int aantal) {
        punten.verhoog(aantal);
    }

    /**
     * Neem één leven weg
     */
    public void verminderLevens () {
        levens.verminder();
    }

}
